# Equations of 7-spin Ising model.

# 30/12/2017
from numpy import zeros, exp

def calc_observables(params):
	"""
	Give each set of parameters concatenated into one array.
	"""
	Cout = zeros((28))
	H = params[0:7]
	J = params[7:28]
	Z = +exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])
	Cout[0] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1)/Z
	Cout[1] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1)/Z
	Cout[2] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1)/Z
	Cout[3] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1)/Z
	Cout[4] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1)/Z
	Cout[5] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1)/Z
	Cout[6] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1)/Z
	Cout[7] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[8] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[9] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[10] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[11] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[12] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[13] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[14] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[15] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[16] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[17] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[18] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[19] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[20] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[21] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[22] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[23] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[24] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[25] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[26] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z
	Cout[27] = (+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])*-1+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20]))/Z

	return(Cout)

def p(params):
	"""
	Give each set of parameters concatenated into one array.
	"""
	Cout = zeros((28))
	H = params[0:7]
	J = params[7:28]
	H = params[0:7]
	J = params[7:28]
	Pout = zeros((128))
	Z = +exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])+exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])
	Pout[0] = +exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])/Z
	Pout[1] = +exp(+H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])/Z
	Pout[2] = +exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])/Z
	Pout[3] = +exp(+H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])/Z
	Pout[4] = +exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])/Z
	Pout[5] = +exp(+H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])/Z
	Pout[6] = +exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])/Z
	Pout[7] = +exp(+H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])/Z
	Pout[8] = +exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])/Z
	Pout[9] = +exp(+H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])/Z
	Pout[10] = +exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])/Z
	Pout[11] = +exp(+H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])/Z
	Pout[12] = +exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])/Z
	Pout[13] = +exp(+H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])/Z
	Pout[14] = +exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])/Z
	Pout[15] = +exp(+H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])/Z
	Pout[16] = +exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])/Z
	Pout[17] = +exp(+H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])/Z
	Pout[18] = +exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])/Z
	Pout[19] = +exp(+H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])/Z
	Pout[20] = +exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])/Z
	Pout[21] = +exp(+H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])/Z
	Pout[22] = +exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])/Z
	Pout[23] = +exp(+H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])/Z
	Pout[24] = +exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])/Z
	Pout[25] = +exp(+H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])/Z
	Pout[26] = +exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])/Z
	Pout[27] = +exp(+H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])/Z
	Pout[28] = +exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])/Z
	Pout[29] = +exp(+H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])/Z
	Pout[30] = +exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])/Z
	Pout[31] = +exp(+H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])/Z
	Pout[32] = +exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])/Z
	Pout[33] = +exp(+H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])/Z
	Pout[34] = +exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])/Z
	Pout[35] = +exp(+H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])/Z
	Pout[36] = +exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])/Z
	Pout[37] = +exp(+H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])/Z
	Pout[38] = +exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])/Z
	Pout[39] = +exp(+H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])/Z
	Pout[40] = +exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])/Z
	Pout[41] = +exp(+H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])/Z
	Pout[42] = +exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])/Z
	Pout[43] = +exp(+H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])/Z
	Pout[44] = +exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])/Z
	Pout[45] = +exp(+H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])/Z
	Pout[46] = +exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])/Z
	Pout[47] = +exp(+H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])/Z
	Pout[48] = +exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])/Z
	Pout[49] = +exp(+H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])/Z
	Pout[50] = +exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])/Z
	Pout[51] = +exp(+H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])/Z
	Pout[52] = +exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])/Z
	Pout[53] = +exp(+H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])/Z
	Pout[54] = +exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])/Z
	Pout[55] = +exp(+H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])/Z
	Pout[56] = +exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])/Z
	Pout[57] = +exp(+H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])/Z
	Pout[58] = +exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])/Z
	Pout[59] = +exp(+H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])/Z
	Pout[60] = +exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])/Z
	Pout[61] = +exp(+H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])/Z
	Pout[62] = +exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])/Z
	Pout[63] = +exp(+H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])/Z
	Pout[64] = +exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]+H[6]-J[0]-J[1]-J[2]-J[3]-J[4]-J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])/Z
	Pout[65] = +exp(-H[0]+H[1]+H[2]+H[3]+H[4]+H[5]-H[6]-J[0]-J[1]-J[2]-J[3]-J[4]+J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])/Z
	Pout[66] = +exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]+H[6]-J[0]-J[1]-J[2]-J[3]+J[4]-J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])/Z
	Pout[67] = +exp(-H[0]+H[1]+H[2]+H[3]+H[4]-H[5]-H[6]-J[0]-J[1]-J[2]-J[3]+J[4]+J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])/Z
	Pout[68] = +exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]+H[6]-J[0]-J[1]-J[2]+J[3]-J[4]-J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])/Z
	Pout[69] = +exp(-H[0]+H[1]+H[2]+H[3]-H[4]+H[5]-H[6]-J[0]-J[1]-J[2]+J[3]-J[4]+J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])/Z
	Pout[70] = +exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]+H[6]-J[0]-J[1]-J[2]+J[3]+J[4]-J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])/Z
	Pout[71] = +exp(-H[0]+H[1]+H[2]+H[3]-H[4]-H[5]-H[6]-J[0]-J[1]-J[2]+J[3]+J[4]+J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])/Z
	Pout[72] = +exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]+H[6]-J[0]-J[1]+J[2]-J[3]-J[4]-J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])/Z
	Pout[73] = +exp(-H[0]+H[1]+H[2]-H[3]+H[4]+H[5]-H[6]-J[0]-J[1]+J[2]-J[3]-J[4]+J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])/Z
	Pout[74] = +exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]+H[6]-J[0]-J[1]+J[2]-J[3]+J[4]-J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])/Z
	Pout[75] = +exp(-H[0]+H[1]+H[2]-H[3]+H[4]-H[5]-H[6]-J[0]-J[1]+J[2]-J[3]+J[4]+J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])/Z
	Pout[76] = +exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]+H[6]-J[0]-J[1]+J[2]+J[3]-J[4]-J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])/Z
	Pout[77] = +exp(-H[0]+H[1]+H[2]-H[3]-H[4]+H[5]-H[6]-J[0]-J[1]+J[2]+J[3]-J[4]+J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])/Z
	Pout[78] = +exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]+H[6]-J[0]-J[1]+J[2]+J[3]+J[4]-J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])/Z
	Pout[79] = +exp(-H[0]+H[1]+H[2]-H[3]-H[4]-H[5]-H[6]-J[0]-J[1]+J[2]+J[3]+J[4]+J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])/Z
	Pout[80] = +exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]+H[6]-J[0]+J[1]-J[2]-J[3]-J[4]-J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])/Z
	Pout[81] = +exp(-H[0]+H[1]-H[2]+H[3]+H[4]+H[5]-H[6]-J[0]+J[1]-J[2]-J[3]-J[4]+J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])/Z
	Pout[82] = +exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]+H[6]-J[0]+J[1]-J[2]-J[3]+J[4]-J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])/Z
	Pout[83] = +exp(-H[0]+H[1]-H[2]+H[3]+H[4]-H[5]-H[6]-J[0]+J[1]-J[2]-J[3]+J[4]+J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])/Z
	Pout[84] = +exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]+H[6]-J[0]+J[1]-J[2]+J[3]-J[4]-J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])/Z
	Pout[85] = +exp(-H[0]+H[1]-H[2]+H[3]-H[4]+H[5]-H[6]-J[0]+J[1]-J[2]+J[3]-J[4]+J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])/Z
	Pout[86] = +exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]+H[6]-J[0]+J[1]-J[2]+J[3]+J[4]-J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])/Z
	Pout[87] = +exp(-H[0]+H[1]-H[2]+H[3]-H[4]-H[5]-H[6]-J[0]+J[1]-J[2]+J[3]+J[4]+J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])/Z
	Pout[88] = +exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]+H[6]-J[0]+J[1]+J[2]-J[3]-J[4]-J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])/Z
	Pout[89] = +exp(-H[0]+H[1]-H[2]-H[3]+H[4]+H[5]-H[6]-J[0]+J[1]+J[2]-J[3]-J[4]+J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])/Z
	Pout[90] = +exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]+H[6]-J[0]+J[1]+J[2]-J[3]+J[4]-J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])/Z
	Pout[91] = +exp(-H[0]+H[1]-H[2]-H[3]+H[4]-H[5]-H[6]-J[0]+J[1]+J[2]-J[3]+J[4]+J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])/Z
	Pout[92] = +exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]+H[6]-J[0]+J[1]+J[2]+J[3]-J[4]-J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])/Z
	Pout[93] = +exp(-H[0]+H[1]-H[2]-H[3]-H[4]+H[5]-H[6]-J[0]+J[1]+J[2]+J[3]-J[4]+J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])/Z
	Pout[94] = +exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]+H[6]-J[0]+J[1]+J[2]+J[3]+J[4]-J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])/Z
	Pout[95] = +exp(-H[0]+H[1]-H[2]-H[3]-H[4]-H[5]-H[6]-J[0]+J[1]+J[2]+J[3]+J[4]+J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])/Z
	Pout[96] = +exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]+H[6]+J[0]-J[1]-J[2]-J[3]-J[4]-J[5]-J[6]-J[7]-J[8]-J[9]-J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])/Z
	Pout[97] = +exp(-H[0]-H[1]+H[2]+H[3]+H[4]+H[5]-H[6]+J[0]-J[1]-J[2]-J[3]-J[4]+J[5]-J[6]-J[7]-J[8]-J[9]+J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])/Z
	Pout[98] = +exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]+H[6]+J[0]-J[1]-J[2]-J[3]+J[4]-J[5]-J[6]-J[7]-J[8]+J[9]-J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])/Z
	Pout[99] = +exp(-H[0]-H[1]+H[2]+H[3]+H[4]-H[5]-H[6]+J[0]-J[1]-J[2]-J[3]+J[4]+J[5]-J[6]-J[7]-J[8]+J[9]+J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])/Z
	Pout[100] = +exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]+H[6]+J[0]-J[1]-J[2]+J[3]-J[4]-J[5]-J[6]-J[7]+J[8]-J[9]-J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])/Z
	Pout[101] = +exp(-H[0]-H[1]+H[2]+H[3]-H[4]+H[5]-H[6]+J[0]-J[1]-J[2]+J[3]-J[4]+J[5]-J[6]-J[7]+J[8]-J[9]+J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])/Z
	Pout[102] = +exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]+H[6]+J[0]-J[1]-J[2]+J[3]+J[4]-J[5]-J[6]-J[7]+J[8]+J[9]-J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])/Z
	Pout[103] = +exp(-H[0]-H[1]+H[2]+H[3]-H[4]-H[5]-H[6]+J[0]-J[1]-J[2]+J[3]+J[4]+J[5]-J[6]-J[7]+J[8]+J[9]+J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])/Z
	Pout[104] = +exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]+H[6]+J[0]-J[1]+J[2]-J[3]-J[4]-J[5]-J[6]+J[7]-J[8]-J[9]-J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])/Z
	Pout[105] = +exp(-H[0]-H[1]+H[2]-H[3]+H[4]+H[5]-H[6]+J[0]-J[1]+J[2]-J[3]-J[4]+J[5]-J[6]+J[7]-J[8]-J[9]+J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])/Z
	Pout[106] = +exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]+H[6]+J[0]-J[1]+J[2]-J[3]+J[4]-J[5]-J[6]+J[7]-J[8]+J[9]-J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])/Z
	Pout[107] = +exp(-H[0]-H[1]+H[2]-H[3]+H[4]-H[5]-H[6]+J[0]-J[1]+J[2]-J[3]+J[4]+J[5]-J[6]+J[7]-J[8]+J[9]+J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])/Z
	Pout[108] = +exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]+H[6]+J[0]-J[1]+J[2]+J[3]-J[4]-J[5]-J[6]+J[7]+J[8]-J[9]-J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])/Z
	Pout[109] = +exp(-H[0]-H[1]+H[2]-H[3]-H[4]+H[5]-H[6]+J[0]-J[1]+J[2]+J[3]-J[4]+J[5]-J[6]+J[7]+J[8]-J[9]+J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])/Z
	Pout[110] = +exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]+H[6]+J[0]-J[1]+J[2]+J[3]+J[4]-J[5]-J[6]+J[7]+J[8]+J[9]-J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])/Z
	Pout[111] = +exp(-H[0]-H[1]+H[2]-H[3]-H[4]-H[5]-H[6]+J[0]-J[1]+J[2]+J[3]+J[4]+J[5]-J[6]+J[7]+J[8]+J[9]+J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])/Z
	Pout[112] = +exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]+H[6]+J[0]+J[1]-J[2]-J[3]-J[4]-J[5]+J[6]-J[7]-J[8]-J[9]-J[10]-J[11]-J[12]-J[13]-J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])/Z
	Pout[113] = +exp(-H[0]-H[1]-H[2]+H[3]+H[4]+H[5]-H[6]+J[0]+J[1]-J[2]-J[3]-J[4]+J[5]+J[6]-J[7]-J[8]-J[9]+J[10]-J[11]-J[12]-J[13]+J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])/Z
	Pout[114] = +exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]+H[6]+J[0]+J[1]-J[2]-J[3]+J[4]-J[5]+J[6]-J[7]-J[8]+J[9]-J[10]-J[11]-J[12]+J[13]-J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])/Z
	Pout[115] = +exp(-H[0]-H[1]-H[2]+H[3]+H[4]-H[5]-H[6]+J[0]+J[1]-J[2]-J[3]+J[4]+J[5]+J[6]-J[7]-J[8]+J[9]+J[10]-J[11]-J[12]+J[13]+J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])/Z
	Pout[116] = +exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]+H[6]+J[0]+J[1]-J[2]+J[3]-J[4]-J[5]+J[6]-J[7]+J[8]-J[9]-J[10]-J[11]+J[12]-J[13]-J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])/Z
	Pout[117] = +exp(-H[0]-H[1]-H[2]+H[3]-H[4]+H[5]-H[6]+J[0]+J[1]-J[2]+J[3]-J[4]+J[5]+J[6]-J[7]+J[8]-J[9]+J[10]-J[11]+J[12]-J[13]+J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])/Z
	Pout[118] = +exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]+H[6]+J[0]+J[1]-J[2]+J[3]+J[4]-J[5]+J[6]-J[7]+J[8]+J[9]-J[10]-J[11]+J[12]+J[13]-J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])/Z
	Pout[119] = +exp(-H[0]-H[1]-H[2]+H[3]-H[4]-H[5]-H[6]+J[0]+J[1]-J[2]+J[3]+J[4]+J[5]+J[6]-J[7]+J[8]+J[9]+J[10]-J[11]+J[12]+J[13]+J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])/Z
	Pout[120] = +exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]+H[6]+J[0]+J[1]+J[2]-J[3]-J[4]-J[5]+J[6]+J[7]-J[8]-J[9]-J[10]+J[11]-J[12]-J[13]-J[14]-J[15]-J[16]-J[17]+J[18]+J[19]+J[20])/Z
	Pout[121] = +exp(-H[0]-H[1]-H[2]-H[3]+H[4]+H[5]-H[6]+J[0]+J[1]+J[2]-J[3]-J[4]+J[5]+J[6]+J[7]-J[8]-J[9]+J[10]+J[11]-J[12]-J[13]+J[14]-J[15]-J[16]+J[17]+J[18]-J[19]-J[20])/Z
	Pout[122] = +exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]+H[6]+J[0]+J[1]+J[2]-J[3]+J[4]-J[5]+J[6]+J[7]-J[8]+J[9]-J[10]+J[11]-J[12]+J[13]-J[14]-J[15]+J[16]-J[17]-J[18]+J[19]-J[20])/Z
	Pout[123] = +exp(-H[0]-H[1]-H[2]-H[3]+H[4]-H[5]-H[6]+J[0]+J[1]+J[2]-J[3]+J[4]+J[5]+J[6]+J[7]-J[8]+J[9]+J[10]+J[11]-J[12]+J[13]+J[14]-J[15]+J[16]+J[17]-J[18]-J[19]+J[20])/Z
	Pout[124] = +exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]+H[6]+J[0]+J[1]+J[2]+J[3]-J[4]-J[5]+J[6]+J[7]+J[8]-J[9]-J[10]+J[11]+J[12]-J[13]-J[14]+J[15]-J[16]-J[17]-J[18]-J[19]+J[20])/Z
	Pout[125] = +exp(-H[0]-H[1]-H[2]-H[3]-H[4]+H[5]-H[6]+J[0]+J[1]+J[2]+J[3]-J[4]+J[5]+J[6]+J[7]+J[8]-J[9]+J[10]+J[11]+J[12]-J[13]+J[14]+J[15]-J[16]+J[17]-J[18]+J[19]-J[20])/Z
	Pout[126] = +exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]+H[6]+J[0]+J[1]+J[2]+J[3]+J[4]-J[5]+J[6]+J[7]+J[8]+J[9]-J[10]+J[11]+J[12]+J[13]-J[14]+J[15]+J[16]-J[17]+J[18]-J[19]-J[20])/Z
	Pout[127] = +exp(-H[0]-H[1]-H[2]-H[3]-H[4]-H[5]-H[6]+J[0]+J[1]+J[2]+J[3]+J[4]+J[5]+J[6]+J[7]+J[8]+J[9]+J[10]+J[11]+J[12]+J[13]+J[14]+J[15]+J[16]+J[17]+J[18]+J[19]+J[20])/Z

	Pout = Pout[::-1]
	return(Pout)
